#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum SearchEventOriginType {
    #[serde(rename = "WORKBOOK")]
    Workbook,
    #[serde(rename = "TEMPLATE")]
    Template,
    #[serde(rename = "API")]
    Api,
    #[serde(rename = "DATA_REVIEW")]
    DataReview,
    #[serde(rename = "PROCEDURE")]
    Procedure,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl SearchEventOriginType {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            SearchEventOriginType::Workbook => "WORKBOOK",
            SearchEventOriginType::Template => "TEMPLATE",
            SearchEventOriginType::Api => "API",
            SearchEventOriginType::DataReview => "DATA_REVIEW",
            SearchEventOriginType::Procedure => "PROCEDURE",
            SearchEventOriginType::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for SearchEventOriginType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for SearchEventOriginType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for SearchEventOriginType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<SearchEventOriginType, conjure_object::plain::ParseEnumError> {
        match v {
            "WORKBOOK" => Ok(SearchEventOriginType::Workbook),
            "TEMPLATE" => Ok(SearchEventOriginType::Template),
            "API" => Ok(SearchEventOriginType::Api),
            "DATA_REVIEW" => Ok(SearchEventOriginType::DataReview),
            "PROCEDURE" => Ok(SearchEventOriginType::Procedure),
            v => v.parse().map(|v| SearchEventOriginType::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for SearchEventOriginType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<SearchEventOriginType, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the SearchEventOriginType enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
